<?php

/**
 * Content of the latest posts
 *
 * @package ContentOfLatestPosts
 * @version 2.4
 * @author davidhs
 * @copyright 2010-2018 by davidhs
 * @license Creative Commons Attribution 3.0 Unported License https://creativecommons.org/licenses/by/3.0/
 */

if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once (dirname(__FILE__) . '/SSI.php');
elseif (!defined('SMF'))
	exit('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

// Installs.
if (empty($context['uninstalling']))
{
	// Upgrades from 1.x to 2.0.
	if (!isset($modSettings['colp_predefined_ids']))
	{
		$ids = array();
		$ids2 = array('default');
		$no_ids = array();
		for ($id = 1; $id <= 5; $id++)
		{
			if (!empty($modSettings['colp_predefined_' . $id]))
			{
				$ids[] = $id;
				$ids2[] = 'predefined_' . $id;
			}
			else
				$no_ids[] = $id;
		}

		$setArray = array();
		$setArray['colp_predefined_ids'] = implode(',', $ids);
		foreach ($ids2 as $id2)
		{
			$setArray['colp_' . $id2 . '_description'] = isset($modSettings['colp_' . $id2 . '_description']) ? $smcFunc['htmlspecialchars']($modSettings['colp_' . $id2 . '_description'], ENT_QUOTES) : '';
			$setArray['colp_' . $id2 . '_header'] = isset($modSettings['colp_' . $id2 . '_bbc']) ? $modSettings['colp_' . $id2 . '_bbc'] : '';
			$setArray['colp_' . $id2 . '_not_content'] = isset($modSettings['colp_' . $id2 . '_not_content']) ? $modSettings['colp_' . $id2 . '_not_content'] : '';
			$setArray['colp_' . $id2 . '_type'] = !empty($modSettings['colp_' . $id2 . '_type']) ? $modSettings['colp_' . $id2 . '_type'] : 'all';

			if (empty($modSettings['colp_' . $id2 . '_boards']))
				$setArray['colp_' . $id2 . '_boards'] = 'current';
			else
			{
				$boards = explode(',', $modSettings['colp_' . $id2 . '_boards']);
				$setArray['colp_' . $id2 . '_boards'] = in_array('all', $boards) ? 'all' : $modSettings['colp_' . $id2 . '_boards'];
			}

			if (empty($modSettings['colp_' . $id2 . '_child_boards']))
				$setArray['colp_' . $id2 . '_child_boards'] = 0;
			elseif ('all' == $modSettings['colp_' . $id2 . '_child_boards'] || 255 < (int) $modSettings['colp_' . $id2 . '_child_boards'])
				$setArray['colp_' . $id2 . '_child_boards'] = '';
			else
				$setArray['colp_' . $id2 . '_child_boards'] = $modSettings['colp_' . $id2 . '_child_boards'];

			$setArray['colp_' . $id2 . '_group'] = empty($modSettings['colp_' . $id2 . '_group']) ? 1 : 0;

			$setArray['colp_' . $id2 . '_boards_link'] = !empty($modSettings['colp_' . $id2 . '_boards_link']) ? $modSettings['colp_' . $id2 . '_boards_link'] : 'all';

			if (empty($modSettings['colp_' . $id2 . '_number_by_group']) || 'all' == $modSettings['colp_' . $id2 . '_number_by_group'])
				$setArray['colp_' . $id2 . '_number_by_group'] = 0;
			else
				$setArray['colp_' . $id2 . '_number_by_group'] = $modSettings['colp_' . $id2 . '_number_by_group'];

			if (empty($modSettings['colp_' . $id2 . '_number_by_topic']) || 'all' == $modSettings['colp_' . $id2 . '_number_by_topic'])
				$setArray['colp_' . $id2 . '_number_by_topic'] = 0;
			else
				$setArray['colp_' . $id2 . '_number_by_topic'] = $modSettings['colp_' . $id2 . '_number_by_topic'];

			$setArray['colp_' . $id2 . '_age'] = !empty($modSettings['colp_' . $id2 . '_age']) ? $modSettings['colp_' . $id2 . '_age'] : 0;
			$setArray['colp_' . $id2 . '_unread'] = !empty($modSettings['colp_' . $id2 . '_unread']) ? $modSettings['colp_' . $id2 . '_unread'] : 'no';
			$setArray['colp_' . $id2 . '_date'] = !empty($modSettings['colp_' . $id2 . '_date']) ? $modSettings['colp_' . $id2 . '_date'] : 'create';
			$setArray['colp_' . $id2 . '_sticky'] = !empty($modSettings['colp_' . $id2 . '_sticky']) ? $modSettings['colp_' . $id2 . '_sticky'] : 'all';
			$setArray['colp_' . $id2 . '_locked'] = !empty($modSettings['colp_' . $id2 . '_locked']) ? $modSettings['colp_' . $id2 . '_locked'] : 'all';
		}

		$replaceArray = array();
		foreach ($setArray as $variable => $value)
			$replaceArray[] = array($variable, $value);

		$smcFunc['db_insert']('replace',
			'{db_prefix}settings',
			array('variable' => 'string-255', 'value' => 'string-65534'),
			$replaceArray,
			array('variable')
		);

		foreach ($no_ids as $no_id)
		{
			$smcFunc['db_query']('', '
				DELETE FROM {db_prefix}settings
				WHERE variable LIKE {string:filter}',
				array(
					'filter' => 'colp\\_predefined\\_' . $no_id . '\\_%',
				)
			);
		}

		for ($id = 1; $id <= 5; $id++)
		{
			$smcFunc['db_query']('', '
				DELETE FROM {db_prefix}settings
				WHERE variable = {string:variable}',
				array(
					'variable' => 'colp_predefined_' . $id,
				)
			);
		}

		$smcFunc['db_query']('', '
			DELETE FROM {db_prefix}settings
			WHERE variable LIKE {string:filter}',
			array(
				'filter' => 'colp\\_%\\_bbc',
			)
		);

		// Kill the cache - it needs redoing now, but we won't bother ourselves with that here.
		cache_put_data('modSettings', null, 90);
	}

	// Installs from 2.0.x to 2.1.
	$ids2 = array();
	if (isset($modSettings['colp_default_description']))
		$ids2[] = 'default';
	if (!empty($modSettings['colp_predefined_ids']))
	{
		$ids = explode(',', $modSettings['colp_predefined_ids']);
		foreach ($ids as $id)
			$ids2[] = 'predefined_' . $id;
	}

	if (!empty($ids2) && !isset($modSettings['colp_' . $ids2[0] . '_group_letters']))
	{
		$setArray = array();
		foreach ($ids2 as $id2)
		{
			$setArray['colp_' . $id2 . '_group'] = empty($modSettings['colp_' . $id2 . '_group']) ? 'no' : 'board';
			$setArray['colp_' . $id2 . '_group_letters'] = '';
			$setArray['colp_' . $id2 . '_group_prefix'] = '';
			$setArray['colp_' . $id2 . '_show_boards'] = '1';
			$setArray['colp_' . $id2 . '_show_subject'] = '1';
			$setArray['colp_' . $id2 . '_show_poster'] = '1';
			$setArray['colp_' . $id2 . '_show_content'] = '1';
			$setArray['colp_' . $id2 . '_order_by'] = 'date_desc';
		}

		$replaceArray = array();
		foreach ($setArray as $variable => $value)
			$replaceArray[] = array($variable, $value);

		$smcFunc['db_insert']('replace',
			'{db_prefix}settings',
			array('variable' => 'string-255', 'value' => 'string-65534'),
			$replaceArray,
			array('variable')
		);

		// Kill the cache - it needs redoing now, but we won't bother ourselves with that here.
		cache_put_data('modSettings', null, 90);
	}

	// Installs from 2.1-2.2 to 2.3.
	if (!empty($ids2) && !isset($modSettings['colp_' . $ids2[0] . '_first_post_topic']))
	{
		$setArray = array();
		foreach ($ids2 as $id2)
		{
			$setArray['colp_' . $id2 . '_first_post_topic'] = '1';
			$setArray['colp_' . $id2 . '_replies_topic'] = '1';
			$setArray['colp_' . $id2 . '_no_subject_prefix'] = '';
		}

		$replaceArray = array();
		foreach ($setArray as $variable => $value)
			$replaceArray[] = array($variable, $value);

		$smcFunc['db_insert']('replace',
			'{db_prefix}settings',
			array('variable' => 'string-255', 'value' => 'string-65534'),
			$replaceArray,
			array('variable')
		);

		// Kill the cache - it needs redoing now, but we won't bother ourselves with that here.
		cache_put_data('modSettings', null, 90);
	}

	// Installs from 2.3 to 2.4.
	if (!empty($ids2) && !isset($modSettings['colp_' . $ids2[0] . '_show_icon']))
	{
		$setArray = array();
		foreach ($ids2 as $id2)
		{
			$setArray['colp_' . $id2 . '_show_icon'] = '1';
			$setArray['colp_' . $id2 . '_format_type'] = 'html';
			$setArray['colp_' . $id2 . '_format_gr_begin'] = '';
			$setArray['colp_' . $id2 . '_format_content'] = '';
			$setArray['colp_' . $id2 . '_format_gr_end'] = '';
			$setArray['colp_' . $id2 . '_subject_prefix'] = '';
		}

		$replaceArray = array();
		foreach ($setArray as $variable => $value)
			$replaceArray[] = array($variable, $value);

		$smcFunc['db_insert']('replace',
			'{db_prefix}settings',
			array('variable' => 'string-255', 'value' => 'string-65534'),
			$replaceArray,
			array('variable')
		);

		// Kill the cache - it needs redoing now, but we won't bother ourselves with that here.
		cache_put_data('modSettings', null, 90);
	}
}

?>